Industrial.js
=============

> A jQuery-driven library of CSS3 gauges, tanks, and more.

Do you work in an industry that requires the use of web-enabled remote monitoring? Are those systems inefficient because they require the server to render images and send them to clients? Are those systems' front-ends expensive to create because of the current market of toolkits? Do you want to use cutting-edge CSS3 features and jQuery to create a beautiful front-end for your industrial application?

If you answer yes to any of these, **Industrial.js** is for you! This library allows you to create an array of different industrial monitoring components. These components include:

* Tanks
* Thermometers
* Gauges
* LEDs
* and Digital Readouts

With optional sizing and color classes, tick marks, and scales, your industrial application will come to life, allowing your users to gleam the same information, but with far more efficiency and style. Not to mention that this toolkit is MIT licensed (i.e. it's free!).

[Go ahead, give the example a try!](http://valdez42.github.com/industrial-js)

[Also view the documentation.](https://github.com/valdez42/industrial-js/wiki)

## Contributing ##
If you'd like to help make **Industrial.js** better (whether it be the default CSS or CoffeeScript source), then go right ahead! I encourage it. If you don't want to work on source, you can also help me by posting issues.

## Promotion ##
Are you using **Industrial.js**? Contact me about your website, and I'll see about promoting you on the example page!
